<template>
  <div>
    <h2>Matriz de Dashboards</h2>
    <div class="dashboard-grid">
      <v-sheet
        v-for="dashboard in dashboards"
        :key="dashboard.name"
        :elevation="10"
        border
        rounded
        class="dashboard-item"
      >
        <h3>{{ dashboard.name }}</h3>
        <iframe
          :src="generateDashboardUrl(dashboard.url)"
          width="100%"
          height="600px"
          frameborder="0"
          sandbox="allow-forms allow-scripts allow-same-origin"
        ></iframe>
      </v-sheet>
    </div>
  </div>
</template>

<script lang="ts">
import { defineComponent, ref } from 'vue';

export default defineComponent({
  name: 'GrafanaDashboard',
  setup() {
    const globalParams = {
      orgId: 1,
      refresh: '10s',
      kiosk: true,
      theme: 'light',
      // Reemplaza 'your_auth_token' con tu token real
      authToken: 'glsa_ZSF387mVeZazJda4Kgvto3nSVjr7x7Hw_225ce1d4',
    };

    const dashboards = ref([
      {
        name: 'Dashboard 1',
        url: 'https://grafana.ana.nvilab.vodafone.com/d/6581e46e4e5c7ba40a07646395ef7b23/kubernetes-compute-resources-pod',
      },
      {
        name: 'Dashboard 2',
        url: 'https://grafana.ana.nvilab.vodafone.com/d/3138fa155d5915769fbded898ac09fd9/kubernetes-kubelet',
      },
      {
        name: 'Dashboard 3',
        url: 'https://grafana.ana.nvilab.vodafone.com/d/8b7a8b326d7a6f1f04244066368c67af/kubernetes-networking-namespace-pods',
      },
      {
        name: 'Dashboard 4',
        url: 'https://grafana.ana.nvilab.vodafone.com/d-solo/3138fa155d5915769fbded898ac09fd9/kubernetes-kubelet?panelId=8',
      },
      {
        name: 'Dashboard 5',
        url: 'https://grafana.ana.nvilab.vodafone.com/d/8b7a8b326d7a6f1f04244066368c67af/kubernetes-networking-namespace-pods',
      },
    ]);

    // Función para generar la URL completa con los parámetros globales
    const generateDashboardUrl = (baseUrl: string) => {
      const params = new URLSearchParams({
        orgId: globalParams.orgId.toString(),
        refresh: globalParams.refresh,
        kiosk: globalParams.kiosk.toString(),
        theme: globalParams.theme,
        auth_token: globalParams.authToken,
      });
      return `${baseUrl}?${params.toString()}`;
    };

    return {
      dashboards,
      generateDashboardUrl,
    };
  },
});
</script>

<style scoped>
.dashboard-grid {
  display: flex;
  flex-direction: column; /* Organiza los dashboards en columna */
  gap: 20px; /* Espacio entre los dashboards */
}

.dashboard-item {
  width: 100%; /* Cada dashboard ocupa todo el ancho */
  box-sizing: border-box;
}

h2 {
  text-align: center;
  margin-bottom: 20px;
}

h3 {
  margin: 0;
  padding: 10px;
}
</style>
